#!/bin/sh
#diskpart=`cat /proc/partitions | grep '[sh]d[abcdefgh]2' | head -n 1 |awk '{print $4}'`
#disksize=`cat /proc/partitions | grep $diskpart | head -n 1 |awk '{print $3}'`
#domsize=`fdisk -l | grep '[sh]d[abcdefgh]' | head -n 1 |awk '{print $5}'`
#curdate=`date +"%d %B %Y %X"`

BA_PATH="/mnt"

# read variables
. $BA_PATH/cl_env.sh

# get - backup to FTP
# put - restore from FTP

if [ "$cl_action" != "put" ]; then
  cl_action='get'
fi

if [ ! -b "$cl_devname" ]; then
  echo "device not found: '$cl_devname'" >&2
  exit 1
fi

## show message
#DISPLAY=:0
#[ $cl_action = 'get' ] && OP_TXT='clone' || OP_TXT='deploy'
#xwChoice -title "System message" \
# -question "Device $OP_TXT operation in progress. System will be restarted automatically." &

perform_reboot()
{
  echo "Rebooting"
  reboot
  exit 0
}

cleanup()
{
    mv -f "$BA_PATH/mkclone.sh" "$BA_PATH/mkclone.bak"
    cp "$BA_PATH/menu.lx" "$BA_PATH/menu.lst"
    sleep 10
    perform_reboot
    exit 0
}

trap "" 1
trap "perform_reboot" 2 15

## shutdown running services that may lock ConfigDB
#kill `pidof launcher setup_pan rdpwizard icawizard`
#sleep 1
## stop device management daemon
#kill `pidof dmc`
#sleep 1

# umount device
MNT_DEV=`mount|grep $cl_devname|awk '{print $1}'`
MNT_PNT=`mount|grep $cl_devname|awk '{print $3}'`
[ -n "$MNT_PNT" ] && umount $MNT_PNT

#OPT='-o useHELP_SITE=0 -t 20 -r 3 -V'
OPT='-o useHELP_SITE=0 -r 3 -v'
[ -n "$cl_username" ] && OPT="$OPT -u $cl_username"
[ -n "$cl_password" ] && OPT="$OPT -p $cl_password"

CDOPT="-W 'CWD $cl_path'"

FTPLOG="$BA_PATH/ftp.log"

# device -> TDM (create image)
if [ $cl_action = 'get' ]; then
  CMD="ncftpput"
  OPT="$OPT -m"
  echo $CMD $OPT -c -W "CWD $cl_path" "$cl_server" "$cl_filename" >&2
  dd if="$cl_devname" bs=1M | gzip -1 -c -f | \
  $CMD $OPT -c -W "CWD $cl_path" "$cl_server" "$cl_filename" >$FTPLOG 2>&1
  RC=$?
  if [ $RC -ne 0 ]; then
    echo "Device copy failed for '$cl_devname'" >&2
    FTPOUT=`cat "$FTPLOG"|sed -e "s/^.*\r//g"`
#    kill `pidof xwChoice`
#	xwChoice -title "System message" \
#    -question "Device $OP_TXT operation FAILED.\nFTP command returned:\n$FTPOUT\n\nCheck logfile: $BA_PATH/clone.log\n\nPress Ok to restart device."
    echo "Device $OP_TXT operation FAILED. FTP command returned: $FTPOUT    Check logfile: $BA_PATH/clone.log" 
    cleanup
  fi
  cp -fp "$BA_PATH/clone.xml" "$BA_PATH/$cl_filename.xml"
  echo $CMD $OPT "$cl_server" "$cl_path" "$cl_filename.xml"
  $CMD $OPT "$cl_server" "$cl_path" "$BA_PATH/$cl_filename.xml"
fi

# TDM -> device (deploy image)
if [ $cl_action = 'put' ]; then
  CMD="ncftpget"
  echo $CMD $OPT -W "CWD $cl_path" "$cl_server" "$cl_filename" >&2
  $CMD $OPT -c -W "CWD $cl_path" "$cl_server" "$cl_filename" 2>"$FTPLOG" | gunzip -c | \
  dd of="$cl_devname" bs=1M
  RC=$?
  if [ $RC -ne 0 ]; then
    echo "Device copy failed for '$cl_devname'" >&2
    FTPOUT=`cat "$FTPLOG"|sed -e "s/^.*\r//g"`
#    kill `pidof xwChoice`
#	xwChoice -title "System message" \
#    -question "Device $OP_TXT operation FAILED.\nFTP command returned:\n$FTPOUT\n\nCheck logfile: $BA_PATH/clone.log\n\nPress Ok to restart device."
    echo "Device $OP_TXT operation FAILED. FTP command returned: $FTPOUT  Check logfile: $BA_PATH/clone.log"
    cleanup
  fi
fi

cleanup
